<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblContenidoTemaRepository;

final class TblContenidoTemaService
{
    private TblContenidoTemaRepository $TblContenidoTemaRepository;

    public function __construct(TblContenidoTemaRepository $TblContenidoTemaRepository)
    {
        $this->TblContenidoTemaRepository = $TblContenidoTemaRepository;
    }

    public function checkAndGet(int $TblContenidoTemaId): object
    {
        return $this->TblContenidoTemaRepository->checkAndGet($TblContenidoTemaId);
    }

    public function getAll(): array
    {
        return $this->TblContenidoTemaRepository->getAll();
    }

    public function getOne(int $TblContenidoTemaId): object
    {
        return $this->checkAndGet($TblContenidoTemaId);
    }

    public function create(array $input): object
    {
        $TblContenidoTema = json_decode((string) json_encode($input), false);

        return $this->TblContenidoTemaRepository->create($TblContenidoTema);
    }

    public function update(array $input, int $TblContenidoTemaId): object
    {
        $TblContenidoTema = $this->checkAndGet($TblContenidoTemaId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblContenidoTemaRepository->update($TblContenidoTema, $data);
    }

    public function delete(int $TblContenidoTemaId): void
    {
        $this->checkAndGet($TblContenidoTemaId);
        $this->TblContenidoTemaRepository->delete($TblContenidoTemaId);
    }
}
